#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__='atareao'
__date__ ='$07/02/2011'
#
# A library for access to google weather api
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
import os
def calc_icon_from_condition(condition,isday = True):
	if isday == True:
		if condition.find('rain') != -1 or condition.find('showers') != -1:
			return 'weather-showers' 
		elif condition.find('snow') != -1 or condition.find('icy') != -1 or condition.find('freezing drizzle') != -1:
			return 'weather-snow'
		elif condition.find('storm') != -1 or condition.find('tstorm') != -1 or condition.find('thunderstorm') != -1:
			return 'weather-storm'
		elif condition.find('fog') != -1 or condition.find('haze') != -1 or condition.find('dust') != -1 or condition.find('smoke') != -1 or condition.find('hail') != -1:
			return 'weather-fog'
		elif condition.find('windy') != -1:
			return 'weather-fog'
		elif (condition.find('mostly') != -1 or condition.find('partly') != -1) and condition.find('cloudy') != -1: 
			return 'weather-clouds' 
		elif condition.find('cloudy') != -1 or condition.find('overcast') != -1:
			return 'weather-overcast' 
		elif condition.find('mostly') != -1 and condition.find('sunny') != -1: 
			return 'weather-few-clouds' 
		elif condition.find('sunny') != -1 or condition.find('clear') != -1:
			return 'weather-clear' 
		elif condition.find('not available') != -1:
			return 'weather-severe-alert'			
		elif condition.find('flurries') != -1 or condition.find('mist') != -1 or condition.find('sleet') != -1:
			return 'weather-showers-scattered' 
	else:
		if condition.find('rain') != -1 or condition.find('showers') != -1:
			return 'weather-showers' 
		elif condition.find('snow') != -1 or condition.find('icy') != -1 or condition.find('freezing drizzle') != -1:
			return 'weather-snow'
		elif condition.find('storm') != -1 or condition.find('tstorm') != -1 or condition.find('thunderstorm') != -1:
			return 'weather-storm'
		elif condition.find('fog') != -1 or condition.find('haze') != -1 or condition.find('dust') != -1 or condition.find('smoke') != -1 or condition.find('hail') != -1:
			return 'weather-fog'
		elif condition.find('windy') != -1:
			return 'weather-fog'			
		elif (condition.find('mostly') != -1 or condition.find('partly') != -1) and condition.find('cloudy') != -1: 
			return 'weather-clouds-night' 
		elif condition.find('cloudy') != -1 or condition.find('overcast') != -1:
			return 'weather-overcast' 
		elif condition.find('mostly') != -1 and condition.find('sunny') != -1: 
			return 'weather-few-clouds-night' 
		elif condition.find('sunny') != -1 or condition.find('clear') != -1:
			return 'weather-clear-night' 
		elif condition.find('not available') != -1:
			return 'weather-severe-alert'
		elif condition.find('flurries') != -1 or condition.find('mist') != -1 or condition.find('sleet') != -1:
			return 'weather-showers-scattered' 
	return '*************************************'
if __name__ == '__main__':
	if os.path.exists('conditions.out') == True:
		os.remove('conditions.out')
	f_in = open('conditions.in','r')
	f_out = open('conditions.out','w')
	for condition in f_in.readlines():
		condition = condition[:-1].lower()
		text = condition.capitalize()
		image_day = condition.replace(' ','_')
		image_night = image_day+'_night'
		icon_day = calc_icon_from_condition(condition,True)
		icon_night = calc_icon_from_condition(condition,False)
		f_out.write("CONDITIONS['%s']={'text':_('%s'),'image':'%s','image_night':'%s','icon':'%s','icon_night':'%s'}\n"%(condition,text,image_day,image_night,icon_day,icon_night))
	f_out.close()
	f_in.close()
	exit(0)
