#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__="atareao"
__date__ ="$29-ene-2011$"
#
# <from numbers to letters.>
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import gtk
import goweapi
import locale
import gettext
import os
import commwi
from configurator import GConf

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(commwi.APP, commwi.LANGDIR)
gettext.textdomain(commwi.APP)
_ = gettext.gettext

def redondea(valor):
	valor = valor * 10.0
	return int(valor)/10.0

def cambia(valor,a,SI = True):
	if len(valor) == 0:
		return ''
	valor = float(valor)
	if SI ==False:
		valor = redondea(5.0/9.0 * (valor-32.0))
	if a=='F':
		return str(redondea(valor*9.0/5.0 + 32.0))
	elif a == 'K':
		return str(redondea(valor+273.15))
	return str(valor)

def load_key(key,defecto):
	gconfi = GConf()
	PATH = '/apps/my-weather-indicator/options/'+key
	try:
		valor = gconfi.get_key(PATH)
		return valor
	except ValueError:
		gconfi.set_key(PATH,defecto)
	return defecto
	
class FC(gtk.Dialog):
	def __init__(self,location = 1):
		#***************************************************************
		gtk.Dialog.__init__(self,'my-weather-indicator | '+_('Forecast'),None,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_size_request(800, 400)
		self.connect('destroy', self.close_application)
		self.set_icon_from_file(commwi.ICON)
		#***************************************************************
		if location == 1:
			self.latitude = load_key('latitude',None)
			self.longitude = load_key('longitude',None)
			self.location = load_key('location',None)
			self.temperature = load_key('temperature',None)			
		else:
			self.latitude = load_key('latitude2',None)
			self.longitude = load_key('longitude2',None)
			self.location = load_key('location2',None)
			self.temperature = load_key('temperature',None)						
		#***************************************************************
		vbox0 = gtk.VBox(spacing = 5)
		vbox0.set_border_width(5)
		self.get_content_area().add(vbox0)
		#***************************************************************
		label11  = gtk.Label('<b>'+self.location+'</b>')
		label11.set_markup('<b>'+self.location+'</b>')
		vbox0.pack_start(label11,True,True)
		#***************************************************************
		frame = gtk.Frame()
		vbox0.add(frame)
		#***************************************************************
		hbox1 = gtk.HBox(spacing = 5)
		hbox1.set_border_width(5)
		frame.add(hbox1)
		#***************************************************************
		#
		weather = goweapi.get_weather_from_google(latitude = float(self.latitude), longitude = float(self.longitude),temperature_units = self.temperature)
		temporal_current_conditions = weather['current_conditions']
		forecast = weather['forecasts']
		hbox1.add(self.create_labels())
		hbox1.add(self.create_forecast_dor_day(forecast,0))
		hbox1.add(self.create_forecast_dor_day(forecast,1))
		hbox1.add(self.create_forecast_dor_day(forecast,2))
		hbox1.add(self.create_forecast_dor_day(forecast,3))			
		#***************************************************************
		#
		while gtk.events_pending():
			gtk.main_iteration()
		
		self.show_all()
		while gtk.events_pending():
			gtk.main_iteration()
		
		#
		self.run()
		self.destroy()

	def close_application(self, widget):
		self.destroy()
		
	def create_labels(self):
		table = gtk.Table(rows=9, columns=1, homogeneous=True)
		#***************************************************************
		label1 = gtk.Label(_('Day of week'))
		label1.set_alignment(xalign=0, yalign=0.5)
		table.attach(label1, 0, 1, 0, 1, xoptions = gtk.FILL, yoptions=gtk.EXPAND, xpadding=0, ypadding=5)
		#***************************************************************
		label2 = gtk.Label(_('Condition'))
		label2.set_alignment(xalign=0, yalign=0.5)
		table.attach(label2, 0, 1, 1, 3, xoptions = gtk.FILL, yoptions=gtk.EXPAND, xpadding=0, ypadding=5)
		#***************************************************************
		label4 = gtk.Label(_('High temperature'))
		label4.set_alignment(xalign=0, yalign=0.5)
		table.attach(label4, 0, 1, 3, 4, xoptions = gtk.FILL, yoptions=gtk.EXPAND, xpadding=0, ypadding=5)
		#***************************************************************
		label5 = gtk.Label(_('Low temperature'))
		label5.set_alignment(xalign=0, yalign=0.5)
		table.attach(label5, 0, 1, 4, 5, xoptions = gtk.FILL, yoptions=gtk.EXPAND, xpadding=0, ypadding=5)
		#***************************************************************
		label6 = gtk.Label(_('Sunrise'))
		label6.set_alignment(xalign=0, yalign=0.5)
		table.attach(label6, 0, 1, 5, 6, xoptions = gtk.FILL, yoptions=gtk.EXPAND, xpadding=0, ypadding=5)
		#***************************************************************
		label7 = gtk.Label(_('Sunset'))
		label7.set_alignment(xalign=0, yalign=0.5)
		table.attach(label7, 0, 1, 6, 7, xoptions = gtk.FILL, yoptions=gtk.EXPAND, xpadding=0, ypadding=5)
		#***************************************************************
		label8 = gtk.Label(_('Moon Phase'))
		label8.set_alignment(xalign=0, yalign=0.5)
		table.attach(label8, 0, 1, 7, 9, xoptions = gtk.FILL, yoptions=gtk.EXPAND, xpadding=0, ypadding=5)
		#***************************************************************
		return table

	def create_forecast_dor_day(self,forecast,day):
		table = gtk.Table(rows=9, columns=2, homogeneous=False)
		#***************************************************************
		label1 = gtk.Label(forecast[day]['day_of_week'])
		table.attach(label1, 0, 2, 0, 1, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		image2 = gtk.image_new_from_icon_name(forecast[day]['condition_image'],gtk.ICON_SIZE_DIALOG)
		table.attach(image2, 0, 2, 1, 2, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		label3 = gtk.Label(forecast[day]['condition_text'])
		table.attach(label3, 0, 2, 2, 3, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		image41 = gtk.image_new_from_icon_name('mwi-arrow-hot',gtk.ICON_SIZE_BUTTON)
		image41.set_alignment(xalign=1, yalign=0.5)
		table.attach(image41, 0, 1, 3, 4, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		label42 = gtk.Label(forecast[day]['high'])
		label42.set_alignment(xalign=0, yalign=0.5)
		table.attach(label42, 1, 2, 3, 4, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		image51 = gtk.image_new_from_icon_name('mwi-arrow-cold',gtk.ICON_SIZE_BUTTON)
		image51.set_alignment(xalign=1, yalign=0.5)
		table.attach(image51, 0, 1, 4, 5, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		label52 = gtk.Label(forecast[day]['low'])
		label52.set_alignment(xalign=0, yalign=0.5)
		table.attach(label52, 1, 2, 4, 5, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		image61 = gtk.image_new_from_icon_name(	'mwig-clear',gtk.ICON_SIZE_BUTTON)
		image61.set_alignment(xalign=1, yalign=0.5)
		table.attach(image61, 0, 1, 5, 6, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		label62 = gtk.Label(forecast[day]['sunrise'])
		label62.set_alignment(xalign=0, yalign=0.5)
		table.attach(label62, 1, 2, 5, 6, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		image71 = gtk.image_new_from_icon_name('mwig-clear-night',gtk.ICON_SIZE_BUTTON)
		image71.set_alignment(xalign=1, yalign=0.5)
		table.attach(image71, 0, 1, 6, 7, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		label72 = gtk.Label(forecast[day]['sunset'])
		label72.set_alignment(xalign=0, yalign=0.5)
		table.attach(label72, 1, 2, 6, 7, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		image8 = gtk.image_new_from_icon_name(forecast[day]['moon_icon'],gtk.ICON_SIZE_DND)
		table.attach(image8, 0, 2, 7, 8, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		label9 = gtk.Label(forecast[day]['moon_phase'])
		table.attach(label9, 0, 2, 8, 9, xoptions = gtk.FILL, yoptions=gtk.FILL, xpadding=0, ypadding=5)
		#***************************************************************
		return table

if __name__ == "__main__":
	cm = FC()
	exit(0)
