#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__='atareao'
__date__ ='$07/02/2011'
#
# A library for access to geocode for address
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import urllib
import json

URLDIR = "http://maps.googleapis.com/maps/api/geocode/json?address=%s&sensor=false"
URLINV = "http://maps.google.com/maps/api/geocode/json?latlng=%s,%s&sensor=false"

# {u'results': [{u'address_components': [{u'long_name': u'1600',
#                                         u'short_name': u'1600',
#                                         u'types': [u'street_number']},
#                                        {u'long_name': u'Amphitheatre Pkwy',
#                                         u'short_name': u'Amphitheatre Pkwy',
#                                         u'types': [u'route']},
#                                        {u'long_name': u'Mountain View',
#                                         u'short_name': u'Mountain View',
#                                         u'types': [u'locality',
#                                                    u'political']},
#                                        {u'long_name': u'San Jose',
#                                         u'short_name': u'San Jose',
#                                         u'types': [u'administrative_area_level_3',
#                                                    u'political']},
#                                        {u'long_name': u'Santa Clara',
#                                         u'short_name': u'Santa Clara',
#                                         u'types': [u'administrative_area_level_2',
#                                                    u'political']},
#                                        {u'long_name': u'California',
#                                         u'short_name': u'CA',
#                                         u'types': [u'administrative_area_level_1',
#                                                    u'political']},
#                                        {u'long_name': u'United States',
#                                         u'short_name': u'US',
#                                         u'types': [u'country',
#                                                    u'political']},
#                                        {u'long_name': u'94043',
#                                         u'short_name': u'94043',
#                                         u'types': [u'postal_code']}],
#                u'formatted_address': u'1600 Amphitheatre Pkwy, Mountain View, CA 94043, USA',
#                u'geometry': {u'location': {u'lat': 37.4216227,
#                                            u'lng': -122.0840263},
#                              u'location_type': u'ROOFTOP',
#                              u'viewport': {u'northeast': {u'lat': 37.424770299999999,
#                                                           u'lng': -122.0808787},
#                                            u'southwest': {u'lat': 37.418475100000002,
#                                                           u'lng': -122.0871739}}},
#                u'types': [u'street_address']}],
#  u'status': u'OK'}

def get_direction(address):
	googleResponse = urllib.urlopen(URLDIR % address)
	jsonResponse = json.loads(googleResponse.read())
	direction ={}
	direction['street'] = None
	direction['locality'] = None
	direction['administrative_area_level_3'] = None
	direction['administrative_area_level_2'] = None
	direction['administrative_area_level_1'] = None
	direction['country'] = None
	direction['postal_code'] = None
	direction['formatted_address'] = jsonResponse['results'][0]['formatted_address']
	direction['lat'] = jsonResponse['results'][0]['geometry']['location']['lat']
	direction['lng'] = jsonResponse['results'][0]['geometry']['location']['lng']
	for el in jsonResponse['results'][0]['address_components']:
		if 'route' in el['types']:
			direction['street'] = el['long_name']
		elif 'locality' in el['types']:
			direction['locality'] = el['long_name']
		elif 'administrative_area_level_3' in el['types']:
			direction['administrative_area_level_3'] = el['long_name']
		elif 'administrative_area_level_2' in el['types']:
			direction['administrative_area_level_2'] = el['long_name']
		elif 'administrative_area_level_1' in el['types']:
			direction['administrative_area_level_1'] = el['long_name']
		elif 'country' in el['types']:
			direction['country'] = el['long_name']
		elif 'postal_code' in el['types']:
			direction['postal_code'] = el['long_name']
	direction['formatted_address'] = jsonResponse['results'][0]['formatted_address']
	direction['lat'] = jsonResponse['results'][0]['geometry']['location']['lat']
	direction['lng'] = jsonResponse['results'][0]['geometry']['location']['lng']
	return direction
def get_inv_direction(lat,lon):
	googleResponse = urllib.urlopen(URLINV % (lat,lon))
	jsonResponse = json.loads(googleResponse.read())
	direction ={}
	direction['street'] = None
	direction['locality'] = None
	direction['administrative_area_level_3'] = None
	direction['administrative_area_level_2'] = None
	direction['administrative_area_level_1'] = None
	direction['country'] = None
	direction['postal_code'] = None
	direction['formatted_address'] = jsonResponse['results'][0]['formatted_address']
	direction['lat'] = jsonResponse['results'][0]['geometry']['location']['lat']
	direction['lng'] = jsonResponse['results'][0]['geometry']['location']['lng']
	for el in jsonResponse['results'][0]['address_components']:
		if 'route' in el['types']:
			direction['street'] = el['long_name']
		elif 'locality' in el['types']:
			direction['locality'] = el['long_name']
		elif 'administrative_area_level_3' in el['types']:
			direction['administrative_area_level_3'] = el['long_name']
		elif 'administrative_area_level_2' in el['types']:
			direction['administrative_area_level_2'] = el['long_name']
		elif 'administrative_area_level_1' in el['types']:
			direction['administrative_area_level_1'] = el['long_name']
		elif 'country' in el['types']:
			direction['country'] = el['long_name']
		elif 'postal_code' in el['types']:
			direction['postal_code'] = el['long_name']
	direction['formatted_address'] = jsonResponse['results'][0]['formatted_address']
	direction['lat'] = jsonResponse['results'][0]['geometry']['location']['lat']
	direction['lng'] = jsonResponse['results'][0]['geometry']['location']['lng']
	return direction
if __name__ == "__main__":	
	#print get_direction('20 avenida de la plana, silla, valencia, españa')
	#print get_direction('Mountain View, California')
	d = get_direction('silla, valencia, españa')
	lat = int(d['lat']*1000000)
	lon = int(d['lng']*1000000)
	#################################################################333	
	#print 'http://www.google.com/ig/api?weather=,,,' + str(lat)+','+str(lon)
	#################################################################333
	print get_inv_direction(d['lat'],d['lng'])
