#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$30/10/2010'
#
# My-Weather-Indicator
# An indicator to show the weather
#
# Adding keybiding
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import os
import gobject
import gtk
import appindicator
import urllib2
import pynotify
import locale
import gettext
import glib
import time
import preferences
import dbus
import time
import webbrowser
from datetime import datetime
from forecastw import FC
from preferences import CM
from preferences import load_key
from preferences import is_key
import commwi
import goweapi
from configurator import GConf
from encoderapi import Encoder

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(commwi.APP, commwi.LANGDIR)
gettext.textdomain(commwi.APP)
_ = gettext.gettext

encoder = Encoder()

def internet_on():
	try:
		response=urllib2.urlopen('http://google.com',timeout=1)
		return True
	except urllib2.URLError as err: pass
	return False

def add2menu(menu, text = None, icon = None, conector_event = None, conector_action = None):
	if text != None and icon == None:
		menu_item = gtk.MenuItem(text)
	elif text == None and icon != None:
		menu_item = gtk.ImageMenuItem()
		image = gtk.Image()
		image.set_from_stock(icon,gtk.ICON_SIZE_MENU)
		menu_item.set_image(image)
		menu_item.set_always_show_image(True)
	elif text != None and icon != None:
		menu_item = gtk.ImageMenuItem(text)
		image = gtk.Image()
		image.set_from_stock(icon,gtk.ICON_SIZE_MENU)
		menu_item.set_image(image)
		menu_item.set_always_show_image(True)
	elif icon == None:
		menu_item = gtk.MenuItem(text)
	else:
		menu_item = gtk.SeparatorMenuItem()
	if conector_event != None and conector_action != None:				
		menu_item.connect(conector_event,conector_action)
	menu_item.show()
	menu.append(menu_item)
	return menu_item
	
class MWI():	
	def __init__(self):
		if dbus.SessionBus().request_name('es.atareao.MyWeatherIndicator') != dbus.bus.REQUEST_NAME_REPLY_PRIMARY_OWNER:
			print "application already running"
			exit(0)		
		while is_key('latitude') == False or is_key('longitude') == False or is_key('location') == False or is_key('temperature') == False:
				p=preferences.CM()
				p.run()
				p.destroy()
		#
		self.main_location = load_key('main_location',True)
		self.latitude = load_key('latitude','39.361346')
		self.longitude = load_key('longitude','-0.4126143')
		self.location = load_key('location','Silla, Spain')
		self.show_temperature = load_key('show_temperature',True)
		self.show_notifications = load_key('show_notifications',True)
		#
		self.second_location = load_key('second_location',True)
		self.latitude2 = load_key('latitude2','39.361346')
		self.longitude2 = load_key('longitude2','-0.4126143')
		self.location2 = load_key('location2','Silla, Spain')
		self.show_temperature2 = load_key('show_temperature2',True)
		self.show_notifications2 = load_key('show_notifications2',True)
		#
		self.temperature = load_key('temperature','C')
		self.wind = load_key('wind','km/h')
		self.refresh_time = load_key('refresh_time',5)		

		self.notification_by_time = load_key('notification_by_time',False)
		self.notification_time = load_key('notification_time',5)
		self.notification_when_temperature = load_key('notification_when_temperature',True)
		self.notification_when_humidity = load_key('notification_when_humidity',True)
		self.notification_when_wind = load_key('notification_when_wind',True)
		self.notification_when_condition = load_key('notification_when_condition',True)
		self.icon_light = load_key('icon_light',True)
		#
		self.last_notification = 0
		self.actualization_time = 0#time.time()
		self.current_conditions = None
		self.current_conditions2 = None
		self.preferences_out = False
		self.forecast_out = False
		#
		self.indicator = appindicator.Indicator('My-Weather-Indicator', 'My-Weather-Indicator', appindicator.CATEGORY_APPLICATION_STATUS)
		self.indicator2 = appindicator.Indicator('My-Weather-Indicator2', 'My-Weather-Indicator', appindicator.CATEGORY_APPLICATION_STATUS)
		#
		self.work()
		#
		glib.timeout_add_seconds(60, self.work)
		
	def work(self):
		while internet_on() == False:
			time.sleep(1)
		if (time.time()-self.actualization_time) > self.refresh_time*60:
			self.actualization_time = time.time()
			self.set_menu()
			self.set_menu2()
		return True
		
	def get_help_menu(self):
		help_menu =gtk.Menu()
		#		
		add2menu(help_menu,text = _('Web...'),conector_event = 'activate',conector_action = self.on_menu_project_clicked)
		add2menu(help_menu,text = _('Get help online...'),conector_event = 'activate',conector_action = self.on_menu_help_online_clicked)
		add2menu(help_menu,text = _('Translate this application...'),conector_event = 'activate',conector_action = self.on_menu_translations_clicked)
		add2menu(help_menu,text = _('Report a bug...'),conector_event = 'activate',conector_action = self.on_menu_bugs_clicked)
		add2menu(help_menu)
		add2menu(help_menu,text = _('About'),conector_event = 'activate',conector_action = self.menu_about_response)
		#
		help_menu.show()
		#
		return help_menu
		
	def on_menu_project_clicked(self,widget):
		webbrowser.open('https://launchpad.net/my-weather-indicator')
		
	def on_menu_help_online_clicked(self,widget):
		webbrowser.open('https://answers.launchpad.net/my-weather-indicator')
	
	def on_menu_translations_clicked(self,widget):
		webbrowser.open('https://translations.launchpad.net/my-weather-indicator')
	
	def on_menu_bugs_clicked(self,widget):
		webbrowser.open('https://bugs.launchpad.net/my-weather-indicator')
	
	def set_menu(self):
		self.menu = gtk.Menu()	
		#
		weather = goweapi.get_weather_from_google(latitude = float(self.latitude), longitude = float(self.longitude),temperature_units = self.temperature, wind_units = self.wind)
		temporal_current_conditions = weather['current_conditions']
		forecast = weather['forecasts']
		conditions_changed = False
		print '########################################################'
		print 'Condiciones actuales'
		print temporal_current_conditions
		if len(temporal_current_conditions)!=0:
			if self.current_conditions == None \
			or (self.notification_when_temperature == True and (temporal_current_conditions['temperature'] != self.current_conditions['temperature']))\
			or (self.notification_when_humidity and (temporal_current_conditions['humidity'] != self.current_conditions['humidity'])) \
			or (self.notification_when_wind and (temporal_current_conditions['wind_condition'] != self.current_conditions['wind_condition'])) \
			or (self.notification_when_condition and (temporal_current_conditions['condition'] != self.current_conditions['condition'])):
				conditions_changed = True
			print '########################################################'
			print 'Condiciones guardadas'
			print self.current_conditions
			self.current_conditions = temporal_current_conditions
			########################################################
			add2menu(self.menu, text = _('Location')+': '+self.location)
			add2menu(self.menu, text = _('Temperature')+': '+self.current_conditions['temperature'])
			add2menu(self.menu, text = _('Humidity')+': '+self.current_conditions['humidity'])
			add2menu(self.menu, text = _('Feels like')+': '+self.current_conditions['feels_like'])
			add2menu(self.menu, text = _('Dew Point')+': '+self.current_conditions['dew_point'])
			add2menu(self.menu, text = _('Wind')+': '+self.current_conditions['wind_condition'])
			add2menu(self.menu, text = self.current_conditions['condition_text'],icon = self.current_conditions['condition_image'])
			add2menu(self.menu)
			add2menu(self.menu, text = _('Sunrise')+': '+self.current_conditions['sunrise'],icon = 'mwig-clear')
			add2menu(self.menu, text = _('Sunset')+': '+self.current_conditions['sunset'],icon = 'mwig-clear-night')
			add2menu(self.menu)
			add2menu(self.menu,text = self.current_conditions['moon_phase'], icon = self.current_conditions['moon_icon'])
			add2menu(self.menu)
			self.menu_forecast = add2menu(self.menu, text = _('Forecast'), conector_event = 'activate',conector_action = self.menu_forecast_response)
			self.menu_preferences = add2menu(self.menu, text = _('Preferences'), conector_event = 'activate',conector_action = self.menu_set_preferences_response)
			add2menu(self.menu, text = _('Refresh weather'), conector_event = 'activate',conector_action = self.menu_refresh_weather_response)
			add2menu(self.menu)
			menu_help = add2menu(self.menu, text =_('Help'))
			menu_help.set_submenu(self.get_help_menu())
			add2menu(self.menu)
			add2menu(self.menu, text = _('Exit'), conector_event = 'activate',conector_action = self.menu_exit_response)
			########################################################
			self.menu.show()
			self.indicator.set_menu(self.menu)
			if self.show_temperature == True:
				self.indicator.set_label(self.current_conditions['temperature'])
			else:
				self.indicator.set_label('')
			if self.main_location == True:
				self.indicator.set_status(appindicator.STATUS_ACTIVE)
			else:
				self.indicator.set_status(appindicator.STATUS_PASSIVE)
			if self.icon_light:
				self.indicator.set_icon(self.current_conditions['condition_icon_light'])
			else:
				self.indicator.set_icon(self.current_conditions['condition_icon_dark'])
			########################################################
			if self.show_notifications == True:
				if self.notification_by_time == False and conditions_changed == True:
					msg = _('Conditions in')+' '+self.location+'\n'
					msg += _('Temperature')+': '+self.current_conditions['temperature']+'\n'
					msg += _('Humidity')+': '+self.current_conditions['humidity']+'\n'
					msg += _('Wind')+': '+self.current_conditions['wind_condition']+'\n'			
					msg += self.current_conditions['condition_text']
					self.notification = pynotify.Notification ('My-Weather-Indicator',msg,self.current_conditions['condition_image'])
					self.notification.show()					

				if self.notification_by_time == True and (time.time()-self.last_notification) > self.notification_time*60:
					self.last_notification = time.time()
					msg = _('Conditions in')+' '+self.location+'\n'
					msg += _('Temperature')+': '+self.current_conditions['temperature']+'\n'
					msg += _('Humidity')+': '+self.current_conditions['humidity']+'\n'
					msg += _('Wind')+': '+self.current_conditions['wind_condition']+'\n'			
					msg += self.current_conditions['condition_text']
					self.notification = pynotify.Notification ('My-Weather-Indicator',msg,self.current_conditions['condition_image'])
					self.notification.show()
			while gtk.events_pending():
				gtk.main_iteration()

	def set_menu2(self):
		self.menu2 = gtk.Menu()	
		#
		weather = goweapi.get_weather_from_google(latitude = float(self.latitude2), longitude = float(self.longitude2),temperature_units = self.temperature, wind_units = self.wind)
		temporal_current_conditions = weather['current_conditions']
		forecast = weather['forecasts']
		conditions_changed = False
		if len(temporal_current_conditions)!=0:
			if self.current_conditions2 == None \
			or (self.notification_when_temperature == True and (temporal_current_conditions['temperature'] != self.current_conditions2['temperature']))\
			or (self.notification_when_humidity and (temporal_current_conditions['humidity'] != self.current_conditions2['humidity'])) \
			or (self.notification_when_wind and (temporal_current_conditions['wind_condition'] != self.current_conditions2['wind_condition'])) \
			or (self.notification_when_condition and (temporal_current_conditions['condition'] != self.current_conditions2['condition'])):
				conditions_changed = True
			self.current_conditions2 = temporal_current_conditions
			########################################################
			add2menu(self.menu2, text = _('Location')+': '+self.location2)
			add2menu(self.menu2, text = _('Temperature')+': '+self.current_conditions2['temperature'])
			add2menu(self.menu2, text = _('Humidity')+': '+self.current_conditions2['humidity'])
			add2menu(self.menu2, text = _('Feels like')+': '+self.current_conditions2['feels_like'])
			add2menu(self.menu2, text = _('Dew Point')+': '+self.current_conditions2['dew_point'])
			add2menu(self.menu2, text = _('Wind')+': '+self.current_conditions2['wind_condition'])
			add2menu(self.menu2, text = self.current_conditions2['condition_text'],icon = self.current_conditions2['condition_image'])
			add2menu(self.menu2)
			add2menu(self.menu2, text = _('Sunrise')+': '+self.current_conditions2['sunrise'],icon = 'mwig-clear')
			add2menu(self.menu2, text = _('Sunset')+': '+self.current_conditions2['sunset'],icon = 'mwig-clear-night')
			add2menu(self.menu2)
			add2menu(self.menu2,text = self.current_conditions2['moon_phase'], icon = self.current_conditions2['moon_icon'])
			add2menu(self.menu2)
			self.menu_forecast2 = add2menu(self.menu2, text = _('Forecast'), conector_event = 'activate',conector_action = self.menu_forecast_response2)
			self.menu_preferences2 = add2menu(self.menu2, text = _('Preferences'), conector_event = 'activate',conector_action = self.menu_set_preferences_response)
			add2menu(self.menu2, text = _('Refresh weather'), conector_event = 'activate',conector_action = self.menu_refresh_weather_response)
			add2menu(self.menu2)
			menu_help = add2menu(self.menu2, text =_('Help'))
			menu_help.set_submenu(self.get_help_menu())
			add2menu(self.menu2)
			add2menu(self.menu2, text = _('Exit'), conector_event = 'activate',conector_action = self.menu_exit_response)
			########################################################
			self.menu2.show()
			self.indicator2.set_menu(self.menu2)
			if self.show_temperature2 == True:
				self.indicator2.set_label(self.current_conditions2['temperature'])
			else:
				self.indicator2.set_label('')
			if self.second_location == True:
				self.indicator2.set_status(appindicator.STATUS_ACTIVE)
			else:
				self.indicator2.set_status(appindicator.STATUS_PASSIVE)
			if self.icon_light:
				self.indicator2.set_icon(self.current_conditions2['condition_icon_light'])
			else:
				self.indicator2.set_icon(self.current_conditions2['condition_icon_dark'])
			########################################################
			if self.show_notifications2 == True:
				if self.notification_by_time == False and conditions_changed == True:
					msg = _('Conditions in')+' '+self.location2+'\n'
					msg += _('Temperature')+': '+self.current_conditions2['temperature']+'\n'
					msg += _('Humidity')+': '+self.current_conditions2['humidity']+'\n'
					msg += _('Wind')+': '+self.current_conditions2['wind_condition']+'\n'			
					msg += self.current_conditions2['condition_text']
					self.notification = pynotify.Notification ('My-Weather-Indicator',msg,self.current_conditions2['condition_image'])
					self.notification.show()					

				if self.notification_by_time == True and (time.time()-self.last_notification) > self.notification_time*60:
					self.last_notification = time.time()
					msg = _('Conditions in')+' '+self.location2+'\n'
					msg += _('Temperature')+': '+self.current_conditions2['temperature']+'\n'
					msg += _('Humidity')+': '+self.current_conditions2['humidity']+'\n'
					msg += _('Wind')+': '+self.current_conditions2['wind_condition']+'\n'			
					msg += self.current_conditions2['condition_text']
					self.notification = pynotify.Notification ('My-Weather-Indicator',msg,self.current_conditions2['condition_image'])
					self.notification.show()
			while gtk.events_pending():
				gtk.main_iteration()
		
	def menu_forecast_response(self,widget):	
		self.menu_forecast.set_sensitive(False)
		self.menu_preferences.set_sensitive(False)
		self.menu_forecast2.set_sensitive(False)
		self.menu_preferences2.set_sensitive(False)
		fc = FC(1)			
		self.menu_forecast.set_sensitive(True)
		self.menu_preferences.set_sensitive(True)
		self.menu_forecast2.set_sensitive(True)
		self.menu_preferences2.set_sensitive(True)

	def menu_forecast_response2(self,widget):				
		self.menu_forecast.set_sensitive(False)
		self.menu_preferences.set_sensitive(False)
		self.menu_forecast2.set_sensitive(False)
		self.menu_preferences2.set_sensitive(False)
		fc = FC(2)			
		self.menu_forecast.set_sensitive(True)
		self.menu_preferences.set_sensitive(True)
		self.menu_forecast2.set_sensitive(True)
		self.menu_preferences2.set_sensitive(True)

	
	def menu_set_preferences_response(self,widget):
		self.menu_forecast.set_sensitive(False)
		self.menu_preferences.set_sensitive(False)
		self.menu_forecast2.set_sensitive(False)
		self.menu_preferences2.set_sensitive(False)
		#
		p=preferences.CM()
		while is_key('latitude') == False or is_key('longitude') == False or is_key('location') == False or is_key('temperature') == False:
				p=preferences.CM()
		#
		self.menu_forecast.set_sensitive(True)
		self.menu_preferences.set_sensitive(True)
		self.menu_forecast2.set_sensitive(True)
		self.menu_preferences2.set_sensitive(True)		
		#
		self.main_location = load_key('main_location',True)
		self.latitude = load_key('latitude','39.361346')
		self.longitude = load_key('longitude','-0.4126143')
		self.location = load_key('location','Silla, Spain')
		self.show_temperature = load_key('show_temperature',True)
		self.show_notifications = load_key('show_notifications',True)
		#
		self.second_location = load_key('second_location',True)
		self.latitude2 = load_key('latitude2','39.361346')
		self.longitude2 = load_key('longitude2','-0.4126143')
		self.location2 = load_key('location2','Silla, Spain')
		self.show_temperature2 = load_key('show_temperature2',True)
		self.show_notifications2 = load_key('show_notifications2',True)
		#				
		self.temperature = load_key('temperature','C')
		self.wind = load_key('wind','km/h')
		self.refresh_time = load_key('refresh_time',5)
		self.notification_by_time = load_key('notification_by_time',False)
		self.notification_time = load_key('notification_time',5)
		self.notification_when_temperature = load_key('notification_when_temperature',True)
		self.notification_when_humidity = load_key('notification_when_humidity',True)
		self.notification_when_wind = load_key('notification_when_wind',True)
		self.notification_when_condition = load_key('notification_when_condition',True)
		self.icon_light = load_key('icon_light',True)
		#
		self.set_menu()
		self.set_menu2()
		
	def menu_refresh_weather_response(self,widget):
		self.set_menu()
		self.set_menu2()

	def menu_exit_response(self,widget):
		exit(0)

	def menu_about_response(self,widget):
		widget.set_sensitive(False)
		ad=gtk.AboutDialog()
		ad.set_name(commwi.APPNAME)
		ad.set_version(commwi.VERSION)
		ad.set_copyright('Copyrignt (c) 2011\nLorenzo Carbonell')
		ad.set_comments(_('A weather indicator'))
		ad.set_license(_(''+
		'This program is free software: you can redistribute it and/or modify it\n'+
		'under the terms of the GNU General Public License as published by the\n'+
		'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
		'any later version.\n\n'+
		'This program is distributed in the hope that it will be useful, but\n'+
		'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
		'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
		'more details.\n\n'+
		'You should have received a copy of the GNU General Public License along with\n'+
		'this program.  If not, see <http://www.gnu.org/licenses/>.'))		
		ad.set_website('http://www.atareao.es')
		ad.set_website_label('http://www.atareao.es')
		ad.set_authors(['Pascal De Vuyst <pascal.devuyst@gmail.com>','Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_translator_credits('Antoni Sperka <https://launchpad.net/~antek1004-gmail>\n\
Clemente Junior <https://launchpad.net/~clmnt-jr>\n\
David Štancl <https://launchpad.net/~dstancl-dstancl>\n\
Fabio Lambertini <https://launchpad.net/~fabio-lambe>\n\
Fitoschido <fitoschido@gmail.com>\n\
Giorgio Grappa <https://launchpad.net/~j-monteagudo>\n\
Jiri Grönroos <https://launchpad.net/~jiri-gronroos>\n\
Lorenzo Carbonell <https://launchpad.net/~lorenzo-carbonell>\n\
NykO18 <https://launchpad.net/~nyko18>\n\
Pascal De Vuyst <pascal.devuyst@gmail.com>\n\
R33D3M33R <https://launchpad.net/~r33d3m33r>\n\
Xose M Lamas <https://launchpad.net/~xmgz>\n\
zeugma <https://launchpad.net/~sunder67>')
		ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_artists(['~mohitg <http://mohitg.deviantart.com/>','~MerlinTheRed <http://merlinthered.deviantart.com/>'])
		ad.set_logo(gtk.gdk.pixbuf_new_from_file(commwi.ICON))
		ad.set_icon(gtk.gdk.pixbuf_new_from_file(commwi.ICON))
		ad.set_program_name(commwi.APPNAME)
		ad.run()
		ad.destroy()
		widget.set_sensitive(True)
		
def redondea(valor):
	valor = valor * 10.0
	return int(valor)/10.0

def cambia(valor,a):
	if len(valor)==0:
		return ''
	valor = float(valor)
	if a=='F':
		return str(redondea(valor*9.0/5.0 + 32.0))
	elif a == 'K':
		return str(redondea(valor+273.15))
	return str(valor)

if __name__ == "__main__":
	mwi=MWI()
	gtk.main()
