#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__="atareao"
__date__ ="$29-ene-2011$"
#
# searchlocation.py
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import os
import gtk
import geocodeapi
import locale
import gettext
import commwi

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(commwi.APP, commwi.LANGDIR)
gettext.textdomain(commwi.APP)
_ = gettext.gettext

APPDIR = commwi.APPDIR

def ejecuta(comando):
	args = shlex.split(comando)
	p = subprocess.call(args)
	return p

class SL(gtk.Dialog): # needs GTK, Python, Webkit-GTK
	def __init__(self,parent,latitude='40',longitude='0'):
		gtk.Dialog.__init__(self,'my-weather-indicator | '+_('Search Location'),parent,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, (gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
		self.direction = geocodeapi.get_inv_direction(latitude,longitude)
		if self.direction['locality']!= None and self.direction['country']!=None:
			self.location = self.direction['locality']+', '+self.direction['country']
		elif self.direction['country']!=None:
			self.location = self.direction['country']
		#
		gtk.Dialog.__init__(self)
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_default_size(600, 300)
		self.connect('destroy', self.close_application)
		#
		self.vbox1 = gtk.VBox(spacing = 5)
		self.vbox1.set_border_width(5)
		self.get_content_area().add(self.vbox1)
		#***************************************************************
		self.hbox1 = gtk.HBox(spacing = 5)
		self.hbox1.set_border_width(5)
		self.vbox1.add(self.hbox1)
		#
		self.label1 = gtk.Label(_('Address')+':')
		self.hbox1.pack_start(self.label1,False,False)
		#
		self.entry1 = gtk.Entry()
		self.entry1.set_text(self.location)
		self.hbox1.pack_start(self.entry1,True,True)
		#***************************************************************
		self.button0 = gtk.Button(_('Search location'))		
		self.button0.connect('clicked',self.search_location)
		self.vbox1.pack_start(self.button0,False,False)		
		#***************************************************************
		self.scrolledwindow = gtk.ScrolledWindow()
		self.vbox1.pack_start(self.scrolledwindow,True,True)
		self.textview =gtk.TextView()
		self.scrolledwindow.add(self.textview)
		self.show_all()
		#
		#
		#
	def close_application(self, widget):
		self.hide()
		
	def search_location(self,widget):
		self.direction = geocodeapi.get_direction(self.entry1.get_text())
		ttbuffer=gtk.TextBuffer()
		ttbuffer.set_text(self.direction['formatted_address'])
		self.textview.set_buffer(ttbuffer)
		self.textview.set_editable(False)
		self.textview.set_wrap_mode(gtk.WRAP_WORD)
		
	def get_latitude(self):
		return self.direction['lat']

	def get_longitude(self):
		return self.direction['lng']
		
	def get_location(self):
		if self.direction['locality'] != None:
			return self.direction['locality']+', '+self.direction['country']
		else:
			return self.direction['country']
		return None

if __name__ == "__main__":	
	sl = SL(None)
	if sl.run() == gtk.RESPONSE_ACCEPT:
		print sl.get_latitude()
		print sl.get_longitude()
		print sl.get_location()
	exit(0)
